This file details the changelog of Unicorn Engine.

-------------------------------
[Version 2.1.4]: September 9th, 2025

Hello everyone. It has been a while since last release and we are releasing Unicorn 2.1.4. Though it is a patch release, there are some highlights worth mentioning.

The very first thing is that, Unicorn (finally!) offers consistent PC guarantee in all cases. Well, it might sound weird that why it was not. Generally QEMU is not designed to keep PC synced in all cases for performance and Unicorn once put necessary hacks but those hacks were too hard to maintain. Now we have architecture agnostic mechanism to offer the PC guarantee.

In addition, we offer a standalone unicorn Rust crate `unicorn-engine-sys` to allows users to build their own bindings since v2.1.4. There are also lots of bindings improvements contained in this release.

We also fix the building and distribution issues for macos ARM and distribute wheels again. Our friend @patryk4815 from pwndbg helps sort this out. Kudos to him!

For 2.2.0, personally I wish I could work it out before the end of this year, by merging lots of pending big PRs but my time budget is relatively limited recently. Please aware that 2.2.0 would probably bump QEMU version to 5.1.0 or even higher so semantics could be changed. Any help is highly welcome and please contact @wtdcode if you are keen.

Lastly, I would like to express my deep gratitude to all contributors that help make this release happen, specifically @Evian-Zhang for Rust improvements and unicornafl integration, @Antelox for consistent contributions on our workflows, @amaanq for various huge work, reviews and Rust bindings split, @PhilippTakacs for PR reviews and fix. Again, thanks for every contributor!

Below goes the auto generated release notes. Starting from this tag, the release note will switch to a short passage plus Github generated contents because this makes it easier to follow big changes.

## What's Changed
* bindings/zig: Fix sample_riscv_zig partial writes and logging by @fervagar in https://github.com/unicorn-engine/unicorn/pull/2133
* Fix physical address truncation on 32-bit systems with addressing extensions by @ExhoAR22 in https://github.com/unicorn-engine/unicorn/pull/2139
* refactor(lib): mark pointers as const where possible by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2140
* bindings: ruby: fix unexpected uc_query result pointer type by @anthraxx in https://github.com/unicorn-engine/unicorn/pull/1962
* bindings: ruby: fix version identifier to 2.1.3 by @anthraxx in https://github.com/unicorn-engine/unicorn/pull/2142
* feat(arm): add an `ESR` register by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2155
* fix(rust): watch all source and header files by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2159
* feat(rust): improve ARM CP register ergonomics by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2160
* fix(m68k): correct SR register read by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2161
* fix(python): catch `BaseException` in wrappers instead of `Exception` by @amaanq in https://github.com/unicorn-engine/unicorn/pull/2163
* Remove the size limit for memory read and write (revamped) by @rliebig in https://github.com/unicorn-engine/unicorn/pull/2144
* Loongarch port by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2164
* S390x registers by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2167
* Add from_handle_with_data method by @Evian-Zhang in https://github.com/unicorn-engine/unicorn/pull/2169
* Make Unicorn struct clone-able by @Evian-Zhang in https://github.com/unicorn-engine/unicorn/pull/2170
* Add Display and Error impl for uc_error for Rust bindings by @Evian-Zhang in https://github.com/unicorn-engine/unicorn/pull/2171
* Add edge generated callback by @Evian-Zhang in https://github.com/unicorn-engine/unicorn/pull/2176
* Correctly restore skip_sync_pc_on_exit by @Evian-Zhang in https://github.com/unicorn-engine/unicorn/pull/2181
* Added CFG check and standalone flag for .NET binding by @AdvDebug in https://github.com/unicorn-engine/unicorn/pull/2182
* qemu/configure: make strings command can be redefined by ${STRINGS} by @clan in https://github.com/unicorn-engine/unicorn/pull/2186
* fix x86 pc by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2187
* Patch from Saferewrite by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2188
* fix incorrect ret of trampoline `closure` in `alloc_code_gen_buffer` by @HyperSine in https://github.com/unicorn-engine/unicorn/pull/2197
* reset invalid_error before ram_block_add by @PhilippTakacs in https://github.com/unicorn-engine/unicorn/pull/2189
* add uc_mem_read_virtual by @PhilippTakacs in https://github.com/unicorn-engine/unicorn/pull/2121
* Minor fixes for vmem apis by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2199
* glib_compat/glib_compact: Clear the buffer in g_hash_table_resize by @MarsDoge in https://github.com/unicorn-engine/unicorn/pull/2219
* Enable install for rust bindings by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2224
* Remove ninja installation from macos runners by @scribam in https://github.com/unicorn-engine/unicorn/pull/2225
* Fix `read_sprr_perm` for Apple real CPUs and GitHub Actions; enable Apple ARM64 wheel builds on PyPI. Fixes #2033. by @patryk4815 in https://github.com/unicorn-engine/unicorn/pull/2227
* Bump cmake minimum required version to 3.10 by @scribam in https://github.com/unicorn-engine/unicorn/pull/2226
* Add support for clangarm64 by @scribam in https://github.com/unicorn-engine/unicorn/pull/2228
* Revert "glib_compat/glib_compact: Clear the buffer in g_hash_table_resize" by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2220
* Python bindings: Use ABI3 wheels by @Antelox in https://github.com/unicorn-engine/unicorn/pull/2223
* concurrent control by @wtdcode in https://github.com/unicorn-engine/unicorn/pull/2235

## New Contributors
* @fervagar made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2133
* @ExhoAR22 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2139
* @anthraxx made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1962
* @rliebig made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2144
* @AdvDebug made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2182
* @HyperSine made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2197
* @MarsDoge made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2219
* @patryk4815 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2227

**Full Changelog**: https://github.com/unicorn-engine/unicorn/compare/v2.1.3...v2.1.4

-------------------------------
[Version 2.1.3]: March 7th, 2025

2.1.3 includes a few fixes for distribution and stability issues. We urge users to update their versions as previous version contains security vulnerabilities.

Fix & Improvements

- Several security issues fixes. @PhilippTakacs 
- Add alpine workflow and fix several distribution issues. @Antelox 
- Introduce importlib_resources for py3.8 (EOL already) @Arusekk @Antelox 
- Mips64 improvemtns. @OBarronCS 
- mips related fixes and implement a few registers.
- x86 default cpu model is changed to `UC_CPU_X86_HASWELL` and remove a few quirks.
- Fix CR4 implementation.
- Fix python bindings break changes by adding back `ctl_tlb_mode`. @Antelox 

New Contributors
* @OBarronCS made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2111

Full Changelog: https://github.com/unicorn-engine/unicorn/compare/2.1.2...2.1.3

-------------------------------
[Version 2.1.2]: Feb 13rd, 2025
2.1.2 is a patch release to mainly resolve the stability issue of the 2.1.0 release series and fix a few distribution issues. All users of Unicorn are expected to upgrade. 

Highlights

- macOS arm64 no longer provides binary wheels due to a feature missing from Github Action runners.
- py3.8 support is brought back, python2 wheels are built and test as well and we migrate to cibuildwheel! @Antelox 
- Several polish to python bindings and implement new API. @elicn  @droe 
- Revert previous break changes that return UC_ERR_ARG for non-existing registers. Now this prints a warning. We urge all users relying on this behavior to fix code as soon as possible.
- Fix several segment faults, including a few long-standing random segfault issues.
- Revive previous unicorn 1 test suite and related refactoring. @elicn @Antelox 
- Optimize memory handling and notdirty writes for faster memory access and snapshots, especially useful for fuzzing. @PhilippTakacs 
- RISC-V API updates. @apparentlymart 
- fix UC_HOOK_MEM_READ on aarch64. @glennsec 
- Support UC_TCG_OP_FLAG_CMP for ARM @dotCirill 
- An alternative tag prefixed with "v" is added for golang compatibility.

Fix & Improvements

- Implement UC_ARM64_REG_WSP
- Several fixes on arm64 macos @tbodt 
- reg_read_batch and reg_write_batch @hsa1as 
- Fix pc sync issue for SPARC, MIPS, x86. This also fixes PC sync issue within UC_HOOK_BLOCK hooks.
- Allow cmake to install files on Windows and allow cmake not to generate Unicorn 1 style all-in-one objects archive 
- Make i386 instructions RDTSC and RDTSCP hookable @t0rr3sp3dr0 
- Allow Statically Linking in Go @t0rr3sp3dr0 
- Rust bindings improvements @Sanae6 
- Patch multiple UC_HOOK_MEM callbacks for unaligned access @Michael-c0de 
- Fix UC_MEM_FETCH_PROT for data read
- Remove more Unicorn 1 hacks to improve performance.
- Docs & unit test updates. @saicao 
- Allow uc_ctl_set_page_size() for arm64 @droe 
- Musl builds @clan 
- mips16 fix @ZakDanger 
- Fix UC_HOOK_MEM on arm32 @xndcn 
- Fix heap buffer overflow in op_cksm function @Shivam7-1 


New Contributors
* @droe made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2023
* @Antelox made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2026
* @tbodt made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2049
* @hsa1as made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2060
* @t0rr3sp3dr0 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2066
* @Sanae6 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2069
* @Michael-c0de made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2063
* @Evian-Zhang made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2064
* @glennsec made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2028
* @clan made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2085
* @xndcn made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2091
* @Shivam7-1 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2096
* @amaanq made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2099

Full Changelog: https://github.com/unicorn-engine/unicorn/compare/2.1.1...2.1.2

As usual, thanks to all contributors and sorry if I missed your name here (please tell me @wtdcode !).

Lastly and personally, I would like to express my big thanks to @Antelox @elicn and @PhilippTakacs for spending lots of time improving Unicorn Engine. Also, there are a few big pull requests adding new architectures (RH850, TCI,  LoongArch64, AVR) and I will actively push them to 2.2.0.

-------------------------------
[Version 2.1.1]: Sept 26th, 2024

This is a small release to fix a few urgent issues.

- Remove pkg_resources usage
- Fix wheels distribution for x86_64 macos
- Fix redundant wheel hacks
- Support musllinux distribution

-------------------------------
[Version 2.1.0]: Sept 22nd, 2024

It has been a while since the last release, and 2.1.0 brings several exciting features. Below is the changelog from the latest to the oldest (though not strictly).

Highlights

- Revive QEMU logs, now we have `-DUNICORN_LOGGING=yes` to enable all qemu logs. @BitMaskMixer 
- Faster (up to 40x) write performance by not always doing `store_helper` and cleaning page locks. @tunz @boborjan2
- Brand new python bindings, with strongly typed and many improvements. @elicn 
- Fix to a long-standing MinGW random segfault bug.
- We bring python2 compatibility back.
- We now fully support M1, both building and a pre-built wheel.
- We support snapshot memory now, with a very low overhead copy-on-write fashion. @PhilippTakacs 
- An option to bypass MMU is also added, check our FAQ. @PhilippTakacs 
- A brand new (and modern) java bindings. We are also working to publish it to maven. @nneonneo
- We have zig integrated. @kassane @atipls 
- Now Unicorn no longer allocates 2GB memory for every instance. The memory will be only committed once used and the upper limit can be adjusted with `uc_ctl`.
- New DotNet binding, with published to both Github and Nuget. @TSRBerry 
- The release will attach all binaries, thanks to @marameref 

Fixes & Improvements

- RISCV improvements, but we still have a long way to go. @apparentlymart @ks0777 
- cmake improvements @scribam @es3n1n 
- Various python bindings fix and improvements @bet4it @rhelmot 
- Docs. @gerph @BitMaskMixer 
- Rust bindings. @lockbox @mlgiraud @deadash
- TCG backend fixes. @redoste @StalkR @dglynos 
- PPC32 fixes. @dotCirill 
- Haiku fixes. @kallisti5 
- Improvements to avoid simulator detection. @mrexodia 

New Contributors

* @ks0777 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1736
* @LG3696 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1764
* @PhilippTakacs made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1765
* @edsky made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1754
* @tunz made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1790
* @kassane made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1809
* @Xeonacid made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1807
* @nneonneo made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1830
* @lockbox made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1847
* @mlgiraud made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1849
* @basavesh made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1861
* @hamarituc made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1886
* @StalkR made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1907
* @dotCirill made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1910
* @marameref made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1897
* @redoste made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1922
* @xclusivor made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1929
* @elicn made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1629
* @nganhkhoa made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1942
* @es3n1n made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1960
* @BitMaskMixer made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1977
* @apparentlymart made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1995
* @atipls made their first contribution in https://github.com/unicorn-engine/unicorn/pull/1985
* @omer54463 made their first contribution in https://github.com/unicorn-engine/unicorn/pull/2005

Full Changelog: https://github.com/unicorn-engine/unicorn/compare/2.0.1...2.1.0


Again, thanks for all contributors and sorry if I missed your name here (please tell me @wtdcode !). 2.1.1 is also coming because we expect some minor break changes to fix.

-------------------------------
[Version 2.0.1.post1]: Nov 22nd, 2022

This is a small release to complement the previous 2.0.1 release.

Fix:

- Fix the endianness detection in tests.
- Fix the version number in CMakeLists.txt.

-------------------------------
[Version 2.0.1]: Nov 1st, 2022

Unicorn2 makes the first step to [Debian packages](https://tracker.debian.org/pkg/unicorn-engine) and [vcpkg](https://github.com/microsoft/vcpkg/pull/26101)! Thanks @roehling and @LilyWangL !

Features:

- Support building & running on BE hosts. #1710 
- Fix and support `clang-cl` on Windows. #1687 
- Fix python `sdist` and add aarch64 Linux wheels. Note `pip` can build Unicorn2 on M1 now!
- C# binding is refined and upgraded to .Net 6. #1723 

Fix/Improvements:

- Various bindings improvements. #1723
- Improvements for tests. #1684 #1683 #1691 #1711 
- Fail explicitly when VEX.L is set. #1658 
- Fix endianness when writing PPC32 CR register. #1659 
- Fix a bug in `uc_ctl_set_cpu_model` check.
- Fix Tricore PC not updating. #1668 
- Fix the mapping not updated if users modify the mappings in the hooks.
- Handle pathological cases consistently. #1651 
- Fix memory leaks in PPC target. #1680 
- Fix memory leaks in Tricore target. #1681
- Fix MSVC handling in cmake. #1693  
- Fix PC sync-ing problems for `UC_HOOK_BLOCK` hooks.
- Fix PC sync-ed twice when users request a soft restart.
- Prevent overflow with pre-allocated RAM blocks. #1712 
- Add FPCR and FPSR registers #1722 
- Fix ARM CPU state not deep copied.
- Fix PC not sync-ed for memory operation on aarch64.
- Exit invalid store operations early to avoid the target registers being overwritten.
- Improve the support for ARM BE32.

Thanks:

@roehling @LilyWangL @mrexodia @zachriggle @Yu3H0 @rhelmot @relapids @sh4w1 @TSRBerry

-------------------------------
[Version 2.0.0]: July 7th, 2022

Features:

- TriCore Support (#1568)

Fixes/Improvements:

- Build both shared library and static archive as unicorn1 does.
- Misc bindings improvements. #1569 #1600 #1609  #1613 #1616
- Make sure setjmp-setjmp-wrapper-win32 participates in the build. #1604 
- Improve Rust bindings build logic.
- Fix wrong python binding for UC_CTL_TB_REMOVE_CACHE
- Flush translation blocks when the count hook is removed.
- Fix unicorn crash when nested `uc_emu_start` deletes a hook
- Fix CPU not fully resumed when writing PC.
- Don't quit TB if `uc_mem_protect` doesn't change the protection of current TB memory.
- Add type annotations for python bindings.
- Add CPUID hook for python bindings. #1618 
- Don't repeat memory hooks if there is already an unhandled error. #1618 
- Support reads and writes over all Arm SIMD registers #1621
- Fix wrong registers range in python bindings.
- Fix uc_mem_protect on mmio regions
- Fix a UAF caused by hook cache.
- Fix the value collision between UC_MODE_ARMBE8 and UC_MODE_ARM926

Thanks:

@AfoHT @mrexodia @bet4it @lowlyw @ekilmer @ondryaso @QDucasse @PalumboN @uberwoozle

----------------------------------
[Version 2.0.0 rc7]: April 17, 2022

This release is expected to be the real last RC release of Unicorn2. ;)

Features:

- Correctly generate static archives for the static build and have CI auto-tested.
- Rust bindings revised. #1584 
- Compatible with clang-cl compiler. #1581 
- Implement UC_HOOK_INSN for aarch64 MRS/MSR/SYS/SYSL

Fixes/Improvements:

- Several corner cases on our API. #1587 #1595 
- Fix the codegen buffer leak. 
- Rust bindins improvements. #1574 #1575 
- Add "holes" to allow unicorn lib as a drop-in replacement for older ones. #1572 
- s390x backports. #1570 
- Fix exits wrongly removed in nested uc_emu_start
- Fix a possible endless loop for only one translation block in a multithreaded environment.
- Fix wrong PC without `UC_HOOK_CODE` installed.
- Update vb6 bindings license. #1563 
- Fix buffer allocation failure on M1. #1559 
- Fix wrong EFLAGS on startup.
- Fix wrong internal states on nested uc_emu_start.
- Remove armeb-softmmu and aarcheb-softmmu which are usermode targets.
- Advance PPC32 PC. #1558 
- Support UC_PPC_REG_CR.
- Update CI to windows-2019

Thanks:

@shuffle2 @liyansong2018 @rose4096 @nviennot @n1tram1 @iii-i @dzzie @yrashk @bet4it 

----------------------------------
[Version 2.0.0 rc6]: Feburary 13, 2022

This release is expected to be the last RC release of Unicorn2.

Features:

- SystemZ (aka. s390x) support.  #1521   #1547 
- CPUID hook now may return a bool to indicate whether skipping the CPUID instruction.
- ARM/AARCH64 coprocessor registers read/write support. #889 

Fixes/Improvements:

- Rust improvements. More registers enums #1504 Easier to use #1543 #1545 
- M68k improvements. #1507 
- Golang improvements. Enable `uc_ctl_set_model` #1506 
- Unit tests improvements. #1512 
- Various ARM system mode fixes. #1500 #1520 #1525  #1531 
- Read/write arm FPSCR and FPSID. #1453 
- Fix the support for ARMv8
- Fix a large number of memory leaks and unicorn2 now goes with google/oss-fuzz!
- Add more X87 registers.  #1524 
- Add more PPC registers.
- Fix the exception not cleared in python bindings. #1537 
- Correctly support ARM big endian and drops `armeb-softmmu` and `aarch64eb-softmmu`
- Fix ARM CPSR.E not reflected during runtime.
- Resolve fuzzing speed problem on macOS.
- Modernize CmakeFileLists.txt. #1544 
- Fix an issue in nested `uc_emu_start`

Thanks:

@Kritzefitz @zznop @QDucasse @gerph @bet4it @mrexodia @iii-i @jbcayrou @scribam

----------------------------------
[Version 2.0.0 rc5]: November 25, 2021

This release fixes a few urgent bugs and improves performance.

Fixes/Improvements:

- Rust bindings improvements. #1480 #1483
- Allow R/W to cp15 registers. #1481 
- Fix `UC_HOOK_EDGE_GENERATED` not calling for indirect jumps.
- Python bindings build improvements. #1486
- Fix bindings on m1 macOS.
- Support nested `uc_emu_start` calls without context save/restore
- Fix wrong MMIO offset for 32bit targets.
- Fix wrong `uc_mem_unmap` logic for both ram and mmio memory.
- Inline `uc_trace_code` and PC sync to improve performance.
- Various fixes in tests.
- Allow writing to CPSR to switch bank registers.
- Implement MMIO in rust bindings. #1499 

Thanks:

- @domenukk 
- @bet4it 
- @mid-kid
- @Kritzefitz

----------------------------------
[Version 2.0.0 rc4]: November 09, 2021

This is a big release of Unicorn and introduces a few powerful new features and a bunch of fixes. 

New Features:

- New API: uc_ctl, by which you could control CPU models, TB caches or multiple exits etc.
- New Hook: UC_HOOK_EDGE_GENERATED, UC_HOOK_TCG_OPCODE
- RISCV CSR read/write.
- Support reading MIPS hi/lo regs. 7268c2a19bce2db72b90e3ea3b133482c3ff4e58
- OSS Fuzzing building support.
- MSVC 32bit and Android build support.
- Introduce clang-format.

Fixes/Improvements:

- Java bindings improvements. unicorn-engine/unicorn#1461
- API Documents updates. unicorn-engine/unicorn#1459
- Rust bindings improvements. unicorn-engine/unicorn#1462
- Add a go.mod for go bindings.
- CMakeLists.txt improvements as a subproject. #1373
- Fix rust bindings build script and add CI.
- Use binary search to find mappings. unicorn-engine/unicorn#1414
- RISCV:
  - Update pc when exiting execution. unicorn-engine/unicorn#1465
  - Add RISCV control status registers to enable floating. unicorn-engine/unicorn#1469 unicorn-engine/unicorn#1478
  - After `ecall`, pc not advanced. unicorn-engine/unicorn#1477
- Fix tb not invalidated when exiting.
- Fix bindings makefile.
- Fix uc_mem_protect not working. unicorn-engine/unicorn#1468

Thanks:

- @bet4it
- @kabeor
- @chfl4gs 
- @QDucasse
- @h33p
- @geohot
- @cla7aye15I4nd
- @jcalabres

----------------------------------
[Version 2.0.0 rc3]: October 06, 2021

This is an urgent pre-release regarding python bindings on older Linux systems.

- Support older Linux distribution, e.g. prior to Ubuntu 19.04
- Fix a memory leak in `uc_close`
- Support building on Android
- Support hooking CPUID instruction.

Enjoy.

----------------------------------
[Version 2.0.0 rc2]: October 05, 2021

This is an urgent pre-release regarding the packaging problem of python bindings.

- Set `zip_false` and `is_pure` to `False` to avoid issues on some Linux distributions.
- Link to `libm` to make sure our libraries work.
- Support to read ST registers in rust bindings.
- Fix #1450

Enjoy.

----------------------------------
[Version 2.0.0 rc1]: October 04, 2021

Unicorn2 first release candidate!

- Based on Qemu 5.0.1
- Remain backward compatible with Unicorn 1.x
- Update ISA of all existing architectures
- Support 2 new architectures in PowerPC & RISCV

----------------------------------
[Unicorn2-beta]: October 3rd, 2021

- Release Unicorn2 beta to public.
- New logo to celebrate this important milestone!

----------------------------------
[Version 1.0.1]: April 20th, 2017

- Properly handle selected-architecture build.
- Fix compilation issues on PPC & S390x.
- Fix a memory leak on uc_mem_protect().
- ARM:
    - Support big-endian mode.
    - Correct instruction size of Thumb/Thumb2 code.
    - Support read/write APSR register.
- ARM64:
    - Support read/write NEON registers.
    - Support read/write NZCV registers.
- Mips: Support read/write Mips64 registers.
- X86: Support read/write MSR.
- Haskell binding: update to the latest API.
- Python: allow not having PATH setup.

----------------------------------
[Version 1.0]: February 23rd, 2017

- Fix build script for BSD host.
- Fix building Unicorn on Arm/PPC/Sparc/S390 hosts.
- X86:
    - Fix 16bit address computation.
    - Fix initial state of segment registers.

----------------------------------
[Version 1.0-rc3]: January 25th, 2017

- Rename API uc_context_free() to uc_free().
- ARM:
    - uc_reg_write() now can modify CPSR register.
	- Add some ARM coproc registers.
- ARM64: uc_reg_read|write() now handles W0-W31 registers.
- Windows: fix a double free bug in uc_close().
- New VB6 binding.
- Java: update to support new APIs from v1.0-rc1.
- Python:
    - Fix memory leaking that prevents UC instances from being GC.
    - Remove some dependencies leftover from glib time.
	- Add new method mem_regions() (linked to uc_mem_regions() API)

----------------------------------
[Version 1.0-rc2]: January 4th, 2017

- Remove glib & pkconfig dependency.
- Python: fix an issue to restore support for FreeBSD (and other *BSD Unix).
- ARM: support MCLASS cpu (Cortex-M3).
- Windows: export a static lib that can be used outside of Mingw

----------------------------------
[Version 1.0-rc1]: December 22nd, 2016

- Lots of bugfixes in all architectures.
- Better support for ARM Thumb.
- Fix many memory leaking issues.
- New bindings: Haskell, MSVC.
- Better support for Python3.
- New APIs: uc_query, uc_reg_write_batch, uc_reg_read_batch, uc_mem_map_ptr, uc_mem_regions, uc_context_alloc, uc_context_save & uc_context_restore.
- New memory hook type: UC_HOOK_MEM_READ_AFTER.
- Add new version macros UC_VERSION_{MAJOR, MINOR, EXTRA}

----------------------------------
[Version 0.9]: October 15th, 2015

- Initial public release.

